#include <bits/stdc++.h>
using namespace std;
using ll = long long;

ll n, m, q, k, x, y, a, b, c;
vector< vector<int> > G;
bool vis[200000];
int tin[200000];
int tout[200000];
int par[200000];
int up[200000][18];
int timer;

void dfs(ll x, ll p) {
    par[x] = p;
    tin[x] = timer++;
    up[x][0] = p;
    vis[x] = 1;
    for (int i = 1; i < 18; i++) {
        up[x][i] = up[up[x][i - 1]][i - 1];
    }
    for (int i : G[x]) {
        if (!vis[i]) {
            dfs(i, x);
        }
    }
    tout[x] = timer++;
}

bool anc(ll x, ll y) {
    return tin[x] <= tin[y] && tout[y] <= tout[x];
}

ll almost_lca(ll x, ll y) {
    for (int i = 17; i >= 0; i--) {
        if (!anc(up[y][i], x)) {
            y = up[y][i];
        }
    }
    return y;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    G.resize(n);
    for (int i = 0; i < n - 1; i++) {
        cin >> x >> y;
        x--;
        y--;
        // cout << x << ' ' << y << endl;
        G[x].push_back(y);
        G[y].push_back(x);
    }
    dfs(0, 0);
    cin >> q;
    while (q --> 0) {
        cin >> x >> y;
        x--;
        y--;
        // cout << x << ' ' << y << endl;
        if (!anc(x, y)) {
            cout << par[x] + 1 << '\n';
        }
        else {
            cout << almost_lca(x, y) + 1 << '\n';
        }
    }
}
