#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;
const int msz = 2e5 + 5;

vector<int> g[msz], tin(msz), tout(msz), p(msz);
int timer = 0;

void dfs(int v, int pr){
    tin[v] = timer++;
    p[v] = pr;
    for (int i: g[v]){
        if (i == pr) continue;
        dfs(i, v);
    }
    tout[v] = timer++;
}

bool check(int a, int b){
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

bool cmp(int x, int y){
    return tin[x] <= tin[y];
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n; cin>>n;
    for (int i = 1; i < n; i++){
        int u, v; cin>>u>>v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1, 0);
    for (int i = 1; i <= n; i++){
        vector<int> nw;
        for (int j: g[i]){
            if (p[j] != i) continue;
            nw.push_back(j);
        }
        g[i] = nw;
        sort(g[i].begin(), g[i].end(), cmp);
    }
    int q; cin>>q;
    while (q--){
        int a, b; cin>>a>>b;
        if (check(a, b)){
            int l = 0, r = (int) g[a].size() - 1;
            while (l + 1 < r){
                int m = (l + r) / 2;
                if (tin[g[a][m]] > tin[b]){
                    r = m - 1;
                }
                else {
                    l = m;
                }
            }
            if (tin[g[a][r]] <= tin[b]) l = r;
            cout<<g[a][l]<<"\n";
            // b -> p[b] -> ... -> a
            continue;
        }
        cout<<p[a]<<"\n";
    }
}