#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;
const int msz = 1e6 + 5;
const int inf = 1e3 + 5;

vector<pii> g[msz];
int h[inf][inf];
int n, m;

vector<pii> adj(int i, int j){
    vector<pii> out;
    if (i > 1) out.push_back({i - 1, j});
    if (j > 1) out.push_back({i, j - 1});
    if (i < n) out.push_back({i + 1, j});
    if (j < m) out.push_back({i, j + 1});
    return out;
}

int f(int i, int j){
    return m * (i - 1) + j;
}

vector<bool> used(msz);

void dfs(int v){
    if (used[v]) return;
    used[v] = true;
    for (auto [i, t]: g[v]){
        if (used[i] || t == 2) continue;
        dfs(i);
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    cin>>n>>m;
    int out = 0;
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            cin>>h[i][j];
            out += (h[i][j] == 1);
        }
    }
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            for (auto [u, v]: adj(i, j)){
                g[f(i, j)].push_back({f(u, v), h[u][v]});
            }
        }
    }
    for (int i = 1; i <= m; i++){
        if (h[1][i] == 1) dfs(f(1, i));
        if (h[n][i] == 1) dfs(f(n, i));
    }
    for (int i = 1; i <= n; i++){
        if (h[i][1] == 1) dfs(f(i, 1));
        if (h[i][m] == 1) dfs(f(i, m));
    }
    int cnt = 0;
    for (bool i: used) cnt += i;
    cout<<out - cnt;
}