#include <bits/stdc++.h>
using namespace std;

#define DIMN 200007

int n, m;
int rt = -1;
vector<int> a[DIMN];
vector<pair<int,int>> q[DIMN];
unordered_map<int,int> mp[DIMN];
int res[DIMN];
int res2[DIMN];

vector<int> dfs(int v, int par) {
    //cout << v << " " << par << endl;
    vector<int> dst(1,v);
    for (auto i : a[v]) {
        if (i==par) continue;
        auto x = dfs(i,v);
        for (auto y : x) {
            res[mp[v][y]] = i+1;
            dst.push_back(y);
        }
    }
    for (auto i : q[v]) if (res[i.second]==0) res[i.second] = par+1;
    return dst;
}

int go(int v, int t, int par) {
    if (v==t) return v;
    for (auto i : a[v]) {
        if (i == par) continue;
        if (go(i,t,v)!=-1) return i;
    }
    return -1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    int u, v;
    for (int i = 0; i < n-1; i++) {
        cin >> u >> v;
        a[u-1].push_back(v-1);
        a[v-1].push_back(u-1);
        if (rt == -1 && a[u-1].size()>1) rt = u-1;
        if (rt == -1 && a[v-1].size()>1) rt = v-1;
    }
    cin >> m;
    for (int i = 0; i < m; i++) {
        cin >> u >> v;
        q[u-1].push_back({v-1,i+1});
        mp[u-1][v-1] = i+1;
        res2[i+1] = go(u-1,v-1,-1);
    }
    //for (int i = 0; i < n; i++) sort(a[i].begin(),a[i].end());
    //for (int i = 0; i < n; i++) sort(q[i].begin(),q[i].end());
    dfs(rt,-1);
    //for (int i = 1; i <= m; i++) cout << res[i] << endl;
    for (int i = 1; i <= m; i++) cout << res2[i]+1 << endl;
    //for (int i = 1; i <= m; i++) cout << res[i] << " " << res2[i]+1 << endl;
}
