#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <queue>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

struct searchnode {
  ll node_index;
  searchnode *parent;
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll n, m, k;
  ll a, b, c, d, e, f, g, h, j, l, mx, mn, sm;
  // freopen("in", "r", stdin);
  string str;
  char ch;
  bool bl;
  cin >> n >> m >> k;
  pair<ll, ll> max_row[n];
  pair<ll, ll> max_col[m];
  sm = 0;
  ll arr[n][m];
  for (ll i = 0; i < n; i++) {
    for (ll j = 0; j < m; j++) {
      cin >> arr[i][j];
      if (arr[i][j] > max_row[i].first) {
        max_row[i] = {arr[i][j], j};
      }
      if (arr[i][j] > max_col[j].first) {
        max_col[j] = {arr[i][j], i};
      }
    }
  }
  for (ll i = 0; i < n; i++) {
    for (ll j = 0; j < m; j++) {
      if (arr[i][j] == max_row[i].first && arr[i][j] == max_col[j].first) {
        sm++;
      }
    }
  }
  while (k--) {
    cin >> a >> b >> c;
    a--;
    b--;
    if (c > max_row[a].first && arr[a][b] < max_row[a].first &&
        max_col[max_row[a].second].first == max_row[a].first) {
      sm--;
    }
    if (c > max_col[b].first && arr[a][b] < max_col[b].first &&
        max_row[max_col[b].second].first == max_col[b].first) {
      sm--;
    }
    if (c > max_row[a].first && c > max_col[b].first &&
        (arr[a][b] < max_row[a].first || arr[a][b] < max_col[b].first)) {
      sm++;
    }
    arr[a][b] = c;
    if (c > max_row[a].first) {
      max_row[a] = {c, b};
    }
    if (c > max_col[b].first) {
      max_col[b] = {c, a};
    }
    cout << sm << nl;
  }
}
