#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <queue>
#include <vector>

using namespace std;

#define ll int
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

struct searchnode {
  ll node_index;
  ll parent;
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll n, m, k;
  ll a, b, c, d, e, f, g, h, j, l, mx, mn, sm;
  //freopen("in", "r", stdin);
  string str;
  char ch;
  bool bl;
  cin >> n;
  vector<ll> arr[n + 1];
  for (ll i = 0; i < n - 1; i++) {
    cin >> a >> b;
    arr[a].push_back(b);
    arr[b].push_back(a);
  }
  ll answers[n + 1][n + 1];
  bool visited[n + 1];
  for (ll i = 1; i <= n; i++) {
    memset(visited, false, n + 1);
    queue<searchnode> bfs;
    bfs.push({i, -1});
    while (!bfs.empty()) {
      searchnode current_search = bfs.front();
      bfs.pop();
      if (visited[current_search.node_index])
        continue;
      visited[current_search.node_index] = true;
      if (current_search.parent != -1) {
        if (current_search.parent == i) {
          answers[i][current_search.node_index] = current_search.node_index;
        } else {
          answers[i][current_search.node_index] =
              answers[i][current_search.parent];
        }
      }
      for (ll child : arr[current_search.node_index]) {
        bfs.push({child, current_search.node_index});
      }
    }
  }
  cin >> k;
  while (k--) {
    cin >> a >> b;
    cout << answers[a][b] << nl;
  }
}
