#include <bits/stdc++.h>
using namespace std;

struct Node{
    int par;
    map<int, int> pred;
};

//Node tree[200005];
Node tree[200005];
pair<int, int> q[200005];
int tick[200005] = {0};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    
    vector<list<int>> ed(n+1);
    for (int i=0, v, u;i<n-1;++i) {
        cin>>v>>u;
        ed[v].push_back(u);
        ed[u].push_back(v);
    }
    int m;
    cin>>m;
    map<pair<int, int>, int> ans;
    for (int i=0, s, t;i<m;++i) {
        cin>>q[i].first>>q[i].second;
        ++tick[q[i].second];
        ans[q[i]] = 0;
    }
    tree[1].par = -1;
    stack<int> st;
    st.push(1);
    int x;
    while (!st.empty()) {
        x = st.top();
        if (ed[x].size()<=1 && tree[x].par != -1) {
            ed[x].clear();
            for (auto itr = tree[x].pred.begin(); itr!=tree[x].pred.end();++itr) {
                if (ans.find({tree[x].par, itr->first}) != ans.end()) {
                    ans[{tree[x].par, itr->first}] = x;
                    --tick[itr->first];
                }
                if (tick[itr->first]) {
                    tree[tree[x].par].pred[itr->first] = x;
                }
            }
            if (tick[x]) tree[tree[x].par].pred[x] = x;
            st.pop();
        } else {
            if (tree[x].par == -1) st.pop();
            for (auto itr=ed[x].begin();itr!=ed[x].end();++itr) {
                if (tree[x].par != (*itr)) {
                    tree[(*itr)].par = x;
                    st.push((*itr));
                }
            }
            ed[x].clear();
        }
    }
    ed.clear();
    for (int i=0;i<m;++i) {
        if (ans[q[i]]) cout<<ans[q[i]]<<'\n';
        else if (q[i].first == 1) cout<<tree[1].pred[q[i].second]<<'\n';
        else cout<<tree[q[i].first].par<<'\n';
    }
    
}
