def get_max_index(array):
    max_elem = 0
    max_index = -1

    for i, elem in enumerate(array):
        if elem > max_elem:
            max_elem = elem
            max_index = i

    return max_elem, max_index

height, width, queries = map(int, input().split(" "))
matrix = []
row_max = []
col_max = []
pike_count = 0

for i in range(height):
    row = list(map(int, input().split(" ")))
    row_max.append(get_max_index(row))
    matrix.append(row)

for j in range(width):
    curr_max = 0
    curr_max_index = -1

    for i in range(height):
        if matrix[i][j] > curr_max:
            curr_max = matrix[i][j]
            curr_max_index = i

    col_max.append((curr_max, curr_max_index))

    if row_max[curr_max_index][1] == j:
        pike_count += 1

del matrix

is_pike = lambda row, col: row_max[row][1] == col and col_max[col][1] == row

for query in range(queries):
    row, col, value = map(int, input().split(" "))
    row -= 1
    col -= 1
    was_pike = is_pike(row, col)

    row_max_value, row_max_index = row_max[row]

    if row_max_index != col and value > row_max_value:
        if is_pike(row, row_max_index):
            pike_count -= 1
        
        row_max[row] = (value, col)

    col_max_value, col_max_index = col_max[col]

    if col_max_index != row and value > col_max_value:
        if is_pike(col_max_index, col):
            pike_count -= 1

        col_max[col] = (value, row)

    if is_pike(row, col) and not was_pike:
        pike_count += 1

    print(pike_count)
