#include <iostream>
#include <vector>
#include <set>
#include <queue>

using namespace std;
using ll = long long;

bool dfs(ll ind, vector<vector<ll>> a, ll searchind, vector<bool>& used) {
    used[ind] = true;
    for (ll i = 0; i < a[ind].size(); i++) {
        if (a[ind][i] == searchind) {
            return true;
        }
        if (!used[a[ind][i]]) {
            if (dfs(a[ind][i], a, searchind, used)) {
                return true;
            }
        }
    }
    return false;
}

void usederase(vector<bool>& used, ll ind) {
    for (ll i = 0; i < used.size(); i++) {
        used[i] = false;
    }
    used[ind] = true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    ll n, input1, input2, m;
    cin >> n;
    vector<vector<ll>> a(n);
    vector<bool> used(n);
    for (ll i = 0; i < n - 1; i++) {
        cin >> input1 >> input2;
        a[input1-1].push_back(input2-1);
        a[input2-1].push_back(input1-1);
    }
    cin >> m;
    for (ll i = 0; i < m; i++) {
        cin >> input1 >> input2;
        usederase(used, input1 - 1);
        for (ll i = 0; i < a[input1-1].size(); i++) {
            if (a[input1-1][i] == input2-1 || dfs(a[input1-1][i], a, input2-1, used)) {
                cout << a[input1-1][i] + 1 << '\n';
                break;
            }
        }
    }
}