#include <iostream>
#include <vector>
#include <queue>

using namespace std;
using ll = long long;

queue<ll> que;

void bfslock(ll ind, vector<pair<vector<ll>, pair<bool, ll>>>& a) {
	for (ll i = 0; i < a[ind].first.size(); i++) {
		if (a[a[ind].first[i]].second.first && a[a[ind].first[i]].second.second >= a[ind].second.second) {
			que.push(a[ind].first[i]);
			a[a[ind].first[i]].second.first = false;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll n, m;
	cin >> n >> m;
	vector<pair<vector<ll>, pair<bool, ll>>> a(m * 1000 + n, { {}, {false, 0} });
	vector<vector<ll>> matrix(n, vector<ll>(m));
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			cin >> matrix[i][j];
			a[j * 1000 + i].second.second = matrix[i][j];
			if (i == 0 || j == 0 || i == n - 1 || j == m - 1) {
				a[j * 1000 + i].second.first = false;
				que.push(j * 1000 + i);
			}
			else {
				a[j * 1000 + i].second.first = true;
			}
			if (j > 0) {
				a[j * 1000 + i].first.push_back((j - 1) * 1000 + i);
			}
			if (i > 0) {
				a[j * 1000 + i].first.push_back(j * 1000 + i - 1);
			}
			if (j < m - 1) {
				a[j * 1000 + i].first.push_back((j + 1) * 1000 + i);
			}
			if (i < n - 1) {
				a[j * 1000 + i].first.push_back(j * 1000 + i + 1);
			}
		}
	}
	while (!que.empty()) {
		bfslock(que.front(), a);
		que.pop();
	}
	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			if (a[j * 1000 + i].second.first) {
				ans++;
			}
		}
	}
	cout << ans << '\n';
}