#include <bits/stdc++.h>
using namespace std;


constexpr int N = 2e5 + 10;

vector<int> adj[N];
int p[N];
int d[N];

void dfs(int node, int cur = 0, int pr = 1) {
    p[node] = pr;
    d[node] = cur;

    for (int ad : adj[node]) {
        if (ad != pr) {
            dfs(ad, cur + 1, node);
        }
    }
}

int binpow[N][20];

int parent(int x, int d) {
    for (int i = 19; i >= 0; i--) {
        if (d >= (1 << i)) {
            x = binpow[x][i];
            d -= (1 << i);
        }
    }
    return x;
}


int ans(int x, int y) {
    if (d[x] >= d[y]) return p[x];

    // d[x] < d[y]

    int par = parent(y, d[y] - d[x]);
    if (par != x) return p[x];
    else return parent(y, d[y] - d[x] - 1);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        adj[x].push_back(y);
        adj[y].push_back(x);
    }

    dfs(1);

    for (int i = 1; i <= n; i++) {
        binpow[i][0] = p[i];
    }

    for (int j = 1; j < 20; j++) {
        for (int i = 1; i <= n; i++) {
            binpow[i][j] = binpow[binpow[i][j - 1]][j - 1];
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int x, y;
        cin >> x >> y;
        printf("%i\n", ans(x, y));
    }
}
