#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <numeric>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';

bool palindrom(lli l, lli r, string s)
{
    lli ssize = r - l + 1;
    for (int i = 0; i < ssize; i++) {
        if (s[l + i] != s[r - i])return false;
    }
    return true;
}

void solve()
{
    string s;
    cin >> s;
    lli n = s.size();
    lli firstna = -1;
    lli lastna = -1;
    for (int i = 0; i < n; i++) {
        if (s[i] != 'a') {
            firstna = i;
            break;
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        if (s[i] != 'a') {
            lastna = i;
            break;
        }
    }
    if (firstna == -1) {
        cout << "Yes";
        return;
    }

    if (firstna >= n - lastna) {
        cout << "No";
        return;
    }

    if (palindrom(firstna, lastna,s)) {
        cout << "Yes";
    }
    else {
        cout << "No";
    }
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

