#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <numeric>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';

struct myq
{
    lli from, to, ind;
};

vector<vector<lli>> g;
vector<vector<myq>> vfrom;
vector<vector<myq>> vto;
vector<lli> res;
vector<lli> used;
vector<vector<lli>> needcheck;


void dfs(lli a,lli p)
{
    if (used[a] == 1)return;
    used[a] = 1;
    for (auto to : vto[a]) {
        if (used[to.from] == 1)needcheck[to.from].push_back(to.ind);
    }

    for (auto to : vfrom[a]) {
        if (used[to.to] == 1)res[to.ind] = p;
    }

    for (auto to : g[a]) {
        dfs(to,a);
        for (int i = needcheck[a].size() - 1; i >= 0;i--) {
            res[needcheck[a][i]] = to;
            needcheck[a].pop_back();
        }
    }
    for (auto to : vfrom[a])if (res[to.ind] == 0)res[to.ind] = p;
}

void solve()
{
    lli n;
    cin >> n;
    vfrom.resize(n + 1);
    vto.resize(n + 1);
    g.resize(n + 1);
    used.resize(n + 1,0);
    needcheck.resize(n + 1);
    for (int i = 1; i < n; i++) {
        lli u1, u2;
        cin >> u1 >> u2;
        g[u1].push_back(u2);
        g[u2].push_back(u1);
    }

    lli m;
    cin >> m;
    res.resize(m + 1);
    for (int i = 1; i <= m; i++) {
        lli from, to;
        cin >> from >> to;
        vfrom[from].push_back({ from,to,i});
        vto[to].push_back({ from,to,i});
    }

    lli start = 1;
    for (int i = 1; i <= n; i++)if (g[i].size() == 1)start = i;
    dfs(start,start);
    for (int i = 1; i <= m; i++)cout << res[i] << LF;
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

