#include <iostream>
#include <vector>
#include <string> 

using namespace std;
typedef long long ll;
int n;
int df(int a) {
	int res = 0;
	while ((1 << res) <= a)
		res++;
	return res;
}

void dfs(int nw, int pr, const vector<vector<int>>& g, vector<vector<int>>& pt, vector<int>& h) {
	int PR = pr;
	if (pr != -1)
		h[nw] = h[pr] + 1;
	pt[nw][0] = pr;
	for (int i = 1; i < pt[nw].size(); i++) {
		if (pr == -1)
			break;
		pr = pt[pr][i - 1];
		pt[nw][i] = pr;
	}
	for (int w : g[nw]) {
		if (w == PR)
			continue;
		dfs(w, nw, g, pt, h);
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	vector<vector<int>> g(n);
	vector<vector<int>> pt(n, vector<int>(df(n), -1));
	vector<int> h(n);

	for (int i = 1; i < n; i++) {
		int v, u;
		cin >> v >> u;
		v--, u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	dfs(0, -1, g, pt, h);
	int q;
	cin >> q;
	while (q--) {
		int s, t;
		cin >> s >> t;
		s--, t--;
		if (h[s] >= h[t]) {
			cout << pt[s][0] + 1 << "\n";
			continue;
		}
		int df = h[t] - h[s] - 1;
		int j = 0;
		while (df) {
			if (df % 2)
				t = pt[t][j];
			j++;
			df /= 2;
		}
		cout << t + 1 << "\n";
	}
}