#include <iostream>
#include <vector>
#include <set>

using namespace std;
using ll = long long;

ll numofpicks(vector<multiset<pair<ll, ll>>> a, vector<multiset<pair<ll, ll>>> b) {
	ll ans = 0;
	for (ll i = 0; i < a.size(); i++) {
		for (ll j = 0; j < b.size(); j++) {
			auto i1 = a[i].end(), j1 = b[j].end();
			i1--; j1--;
			if ((*i1).first == (*j1).first) {
				ans++;
				break;
			}
		}
	}
	return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
	ll n, m, q, inp1, r, c, x;
	cin >> n >> m >> q;
	vector<multiset<pair<ll, ll>>> maxn(n);
	vector<multiset<pair<ll, ll>>> maxm(m);
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			cin >> inp1;
			maxn[i].insert({ inp1, j});
			maxm[j].insert({ inp1, i });
		}
	}
	for (ll i = 0; i < q; i++) {
		cin >> r >> c >> x; 
		r--;
		c--;
		auto k = maxn[r].begin();
		auto end = maxn[r].end();
		for (k; k != end; k++) {
			if ((*k).second == c) {
				maxn[r].erase({(*k).first , c});
				maxn[r].insert({ x, c });
				break;
			}
		}
		auto k1 = maxm[c].begin();
		auto end1 = maxm[c].end();
		for (k1; k1 != end1; k1++) {
			if ((*k1).second == r) {
				maxm[c].erase({ (*k1).first , r });
				maxm[c].insert({ x, r });
				break;
			}
		}
		cout << numofpicks(maxn, maxm) << '\n';
	}
}