#include <iostream>
#include <vector>
#include <set>

using namespace std;
using ll = long long;

ll numofpicks(vector<multiset<pair<ll, ll>>> a, vector<multiset<pair<ll, ll>>> b) {
	ll ans = 0;
	for (ll i = 0; i < a.size(); i++) {
		for (ll j = 0; j < b.size(); j++) {
			auto i1 = a[i].end(), j1 = b[j].end();
			i1--; j1--;
			if ((*i1).first == (*j1).first) {
				ans++;
				break;
			}
		}
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll n, m, q, inp1, r, c, x, ans;
	cin >> n >> m >> q;
	vector<multiset<pair<ll, ll>>> maxn(n);
	vector<multiset<pair<ll, ll>>> maxm(m);
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			cin >> inp1;
			maxn[i].insert({ inp1, j});
			maxm[j].insert({ inp1, i });
		}
	}
	ans = numofpicks(maxn, maxm);
	bool change, change2;
	for (ll i = 0; i < q; i++) {
		cin >> r >> c >> x; 
		r--;
		c--;
		change = false;
		change2 = false;
		auto k = maxn[r].begin();
		auto end = maxn[r].end();
		end--;
		for (k; k != maxn[r].end(); k++) {
			if ((*k).second == c) {
				if (k == end) {
					change2 = true;
				}
				end++;
				maxn[r].erase({(*k).first , c});
				maxn[r].insert({ x, c });
				end--;
				if (maxn[r].find({x, c}) == end && !change2) {
					change = true;
				}
				break;
			}
		}
		auto k1 = maxm[c].begin();
		auto end1 = maxm[c].end();
		end1--;
		for (k1; k1 != maxm[c].end(); k1++) {
			if ((*k1).second == r) {
				if (k1 == end1) {
					change2 = true;
				}
				end1++;
				maxm[c].erase({ (*k1).first , r });
				maxm[c].insert({ x, r });
				end1--;
				if (maxm[c].find({ x, r }) == end1 && !change2) {
					change = true;
				}
				break;
			}
		}
		if (change) {
			ans = numofpicks(maxn, maxm);
		}
		cout << ans << '\n';
	}
}